diff --git a/roms/ipxe/src/hci/commands/image_cmd.c b/roms/ipxe/src/hci/commands/image_cmd.c
index 1ff3ff49be4c8972b97842c3ee3d..6f51a6ba2a0ade3b380692bf381e 100644
--- a/roms/ipxe/src/hci/commands/image_cmd.c
+++ b/roms/ipxe/src/hci/commands/image_cmd.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -26,6 +27,7 @@ FILE_LICENCE ( GPL2_OR_LATER );
 #include <ipxe/image.h>
 #include <ipxe/command.h>
 #include <ipxe/parseopt.h>
+#include <ipxe/shell.h>
 #include <usr/imgmgmt.h>
 
 /** @file
@@ -34,167 +36,258 @@ FILE_LICENCE ( GPL2_OR_LATER );
  *
  */
 
-/** "imgfetch" options */
-struct imgfetch_options {
+/** "img{single}" options */
+struct imgsingle_options {
 	/** Image name */
 	const char *name;
+	/** Replace image */
+	int replace;
+	/** Free image after execution */
+	int autofree;
 };
 
-/** "imgfetch" option list */
-static struct option_descriptor imgfetch_opts[] = {
+/** "img{single}" option list */
+static struct option_descriptor imgsingle_opts[] = {
 	OPTION_DESC ( "name", 'n', required_argument,
-		      struct imgfetch_options, name, parse_string ),
+		      struct imgsingle_options, name, parse_string ),
+	OPTION_DESC ( "replace", 'r', no_argument,
+		      struct imgsingle_options, replace, parse_flag ),
+	OPTION_DESC ( "autofree", 'a', no_argument,
+		      struct imgsingle_options, autofree, parse_flag ),
 };
 
-/** "imgfetch" command descriptor */
-static struct command_descriptor imgfetch_cmd =
-	COMMAND_DESC ( struct imgfetch_options, imgfetch_opts, 1, MAX_ARGUMENTS,
-		       "[--name <name>] <uri> [<arguments>...]" );
+/** "img{single}" command descriptor */
+static struct command_descriptor imgsingle_cmd =
+	COMMAND_DESC ( struct imgsingle_options, imgsingle_opts,
+		       1, MAX_ARGUMENTS,
+		       "[--name <name>] [--autofree] "
+		       "<uri|image> [<arguments>...]" );
+
+/** An "img{single}" family command descriptor */
+struct imgsingle_descriptor {
+	/** Command descriptor */
+	struct command_descriptor *cmd;
+	/** Function to use to acquire the image */
+	int ( * acquire ) ( const char *name, struct image **image );
+	/** Pre-action to take upon image, or NULL */
+	void ( * preaction ) ( struct image *image );
+	/** Action to take upon image, or NULL */
+	int ( * action ) ( struct image *image,
+			   struct imgsingle_options *opts );
+	/** Verb to describe action */
+	const char *verb;
+};
 
 /**
- * The "imgfetch" and friends command body
+ * The "img{single}" family of commands
  *
  * @v argc		Argument count
  * @v argv		Argument list
- * @v cmd		Command descriptor
+ * @v desc		"img{single}" command descriptor
  * @v action_name	Action name (for error messages)
- * @v action		Action to take upon a successful download
+ * @v action		Action to take upon image
  * @ret rc		Return status code
  */
-static int imgfetch_core_exec ( int argc, char **argv,
-				const char *action_name,
-				int ( * action ) ( struct image *image ) ) {
-	struct imgfetch_options opts;
-	char *uri_string;
+static int imgsingle_exec ( int argc, char **argv,
+			    struct imgsingle_descriptor *desc ) {
+	struct imgsingle_options opts;
+	char *name_uri = NULL;
 	char *cmdline = NULL;
+	struct image *image;
 	int rc;
 
 	/* Parse options */
-	if ( ( rc = parse_options ( argc, argv, &imgfetch_cmd, &opts ) ) != 0 )
+	if ( ( rc = parse_options ( argc, argv, desc->cmd, &opts ) ) != 0 )
 		goto err_parse_options;
 
-	/* Parse URI string */
-	uri_string = argv[optind];
+	/* Parse name/URI string and command line, if present */
+	if ( optind < argc ) {
+		name_uri = argv[optind];
+		if ( argv[ optind + 1 ] != NULL ) {
+			cmdline = concat_args ( &argv[ optind + 1 ] );
+			if ( ! cmdline ) {
+				rc = -ENOMEM;
+				goto err_parse_cmdline;
+			}
+		}
+	}
 
-	/* Parse command line */
-	if ( argv[ optind + 1 ] != NULL ) {
-		cmdline = concat_args ( &argv[ optind + 1 ] );
-		if ( ! cmdline ) {
-			rc = -ENOMEM;
-			goto err_cmdline;
+	/* Acquire the image */
+	if ( name_uri ) {
+		if ( ( rc = desc->acquire ( name_uri, &image ) ) != 0 )
+			goto err_acquire;
+	} else {
+		image = image_find_selected();
+		if ( ! image ) {
+			printf ( "No image selected\n" );
+			goto err_acquire;
 		}
 	}
 
-	/* Fetch the image */
-	if ( ( rc = imgdownload_string ( uri_string, opts.name, cmdline,
-					 action ) ) != 0 ) {
-		printf ( "Could not %s %s: %s\n",
-			 action_name, uri_string, strerror ( rc ) );
-		goto err_imgdownload;
+	/* Carry out command pre-action, if applicable */
+	if ( desc->preaction )
+		desc->preaction ( image );
+
+	/* Set the image name, if applicable */
+	if ( opts.name ) {
+		if ( ( rc = image_set_name ( image, opts.name ) ) != 0 ) {
+			printf ( "Could not name image: %s\n",
+				 strerror ( rc ) );
+			goto err_set_name;
+		}
 	}
 
-	/* Free command line */
-	free ( cmdline );
+	/* Set the command-line arguments, if applicable */
+	if ( cmdline ) {
+		if ( ( rc = image_set_cmdline ( image, cmdline ) ) != 0 ) {
+			printf ( "Could not set arguments: %s\n",
+				 strerror ( rc ) );
+			goto err_set_cmdline;
+		}
+	}
 
-	return 0;
+	/* Set the auto-unregister flag, if applicable */
+	if ( opts.autofree )
+		image->flags |= IMAGE_AUTO_UNREGISTER;
 
- err_imgdownload:
+	/* Carry out command action, if applicable */
+	if ( desc->action ) {
+		if ( ( rc = desc->action ( image, &opts ) ) != 0 ) {
+			printf ( "Could not %s: %s\n",
+				 desc->verb, strerror ( rc ) );
+			goto err_action;
+		}
+	}
+
+	/* Success */
+	rc = 0;
+
+ err_action:
+ err_set_cmdline:
+ err_set_name:
+ err_acquire:
 	free ( cmdline );
- err_cmdline:
+ err_parse_cmdline:
  err_parse_options:
 	return rc;
 }
 
+/** "imgfetch" command descriptor */
+static struct command_descriptor imgfetch_cmd =
+	COMMAND_DESC ( struct imgsingle_options, imgsingle_opts,
+		       1, MAX_ARGUMENTS,
+		       "[--name <name>] [--autofree] <uri> [<arguments>...]" );
+
+/** "imgfetch" family command descriptor */
+struct imgsingle_descriptor imgfetch_desc = {
+	.cmd = &imgfetch_cmd,
+	.acquire = imgdownload_string,
+};
+
 /**
- * The "imgfetch"/"module" command
+ * The "imgfetch" command
  *
  * @v argc		Argument count
  * @v argv		Argument list
  * @ret rc		Return status code
  */
 static int imgfetch_exec ( int argc, char **argv ) {
-
-	return imgfetch_core_exec ( argc, argv, "fetch",
-				    register_and_put_image );
+	return imgsingle_exec ( argc, argv, &imgfetch_desc );
 }
 
 /**
- * The "kernel" command
+ * "imgselect" command action
  *
- * @v argc		Argument count
- * @v argv		Argument list
+ * @v image		Image
+ * @v opts		Options
  * @ret rc		Return status code
  */
-static int kernel_exec ( int argc, char **argv ) {
-
-	return imgfetch_core_exec ( argc, argv, "select",
-				    register_and_select_image );
+static int imgselect ( struct image *image,
+		       struct imgsingle_options *opts __unused ) {
+	return image_select ( image );
 }
 
+/** "imgselect" family command descriptor */
+struct imgsingle_descriptor imgselect_desc = {
+	.cmd = &imgsingle_cmd,
+	.acquire = imgacquire,
+	.action = imgselect,
+	.verb = "select",
+};
+
 /**
- * The "chain" command
+ * The "imgselect" command
  *
  * @v argc		Argument count
  * @v argv		Argument list
  * @ret rc		Return status code
  */
-static int chain_exec ( int argc, char **argv) {
-
-	return imgfetch_core_exec ( argc, argv, "boot",
-				    register_and_boot_image );
+static int imgselect_exec ( int argc, char **argv ) {
+	return imgsingle_exec ( argc, argv, &imgselect_desc );
 }
 
-/** "imgselect" options */
-struct imgselect_options {};
-
-/** "imgselect" option list */
-static struct option_descriptor imgselect_opts[] = {};
-
-/** "imgselect" command descriptor */
-static struct command_descriptor imgselect_cmd =
-	COMMAND_DESC ( struct imgselect_options, imgselect_opts, 1, 1,
-		       "<image>" );
+/** "imgexec" command descriptor */
+static struct command_descriptor imgexec_cmd =
+	COMMAND_DESC ( struct imgsingle_options, imgsingle_opts,
+		       0, MAX_ARGUMENTS,
+		       "[--autofree] [--replace] "
+		       "[<uri|image> [<arguments>...]]" );
 
 /**
- * The "imgselect" command
+ * "imgexec" command action
  *
- * @v argc		Argument count
- * @v argv		Argument list
+ * @v image		Image
+ * @v opts		Options
  * @ret rc		Return status code
  */
-static int imgselect_exec ( int argc, char **argv ) {
-	struct imgselect_options opts;
-	struct image *image;
+static int imgexec ( struct image *image, struct imgsingle_options *opts ) {
 	int rc;
 
-	/* Parse options */
-	if ( ( rc = parse_options ( argc, argv, &imgselect_cmd, &opts ) ) != 0 )
-		return rc;
+	/* Perform replacement or execution as applicable */
+	if ( opts->replace ) {
 
-	/* Parse image name */
-	if ( ( rc = parse_image ( argv[optind], &image ) ) != 0 )
-		return rc;
+		/* Try to replace image */
+		if ( ( rc = image_replace ( image ) ) != 0 )
+			return rc;
 
-	/* Load image */
-	if ( ( rc = imgselect ( image ) ) != 0 ) {
-		printf ( "Could not select %s: %s\n",
-			 image->name, strerror ( rc ) );
-		return rc;
+		/* Stop script and tail-recurse into replacement image */
+		shell_stop ( SHELL_STOP_COMMAND_SEQUENCE );
+
+	} else {
+
+		/* Try to execute image */
+		if ( ( rc = image_exec ( image ) ) != 0 )
+			return rc;
 	}
 
 	return 0;
 }
 
-/** "imgargs" options */
-struct imgargs_options {};
+/** "imgexec" family command descriptor */
+struct imgsingle_descriptor imgexec_desc = {
+	.cmd = &imgexec_cmd,
+	.acquire = imgacquire,
+	.action = imgexec,
+	.verb = "boot",
+};
 
-/** "imgargs" option list */
-static struct option_descriptor imgargs_opts[] = {};
+/**
+ * The "imgexec" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int imgexec_exec ( int argc, char **argv) {
+	return imgsingle_exec ( argc, argv, &imgexec_desc );
+}
 
-/** "imgargs" command descriptor */
-static struct command_descriptor imgargs_cmd =
-	COMMAND_DESC ( struct imgargs_options, imgargs_opts, 1, MAX_ARGUMENTS,
-		       "<image> [<arguments>...]" );
+/** "imgargs" family command descriptor */
+struct imgsingle_descriptor imgargs_desc = {
+	.cmd = &imgsingle_cmd,
+	.acquire = imgacquire,
+	.preaction = image_clear_cmdline,
+};
 
 /**
  * The "imgargs" command body
@@ -204,105 +297,60 @@ static struct command_descriptor imgargs_cmd =
  * @ret rc		Return status code
  */
 static int imgargs_exec ( int argc, char **argv ) {
-	struct imgargs_options opts;
-	struct image *image;
-	char *cmdline = NULL;
-	int rc;
-
-	/* Parse options */
-	if ( ( rc = parse_options ( argc, argv, &imgargs_cmd, &opts ) ) != 0 )
-		goto err_parse_options;
-
-	/* Parse image name */
-	if ( ( rc = parse_image ( argv[optind], &image ) ) != 0 )
-		goto err_parse_image;
-
-	/* Parse command line */
-	if ( argv[ optind + 1 ] != NULL ) {
-		cmdline = concat_args ( &argv[ optind + 1 ] );
-		if ( ! cmdline ) {
-			rc = -ENOMEM;
-			goto err_cmdline;
-		}
-	}
-
-	/* Set command line */
-	if ( ( rc = image_set_cmdline ( image, cmdline ) ) != 0 )
-		goto err_set_cmdline;
-
-	/* Free command line */
-	free ( cmdline );
-
-	return 0;
-
- err_set_cmdline:
-	free ( cmdline );
- err_cmdline:
- err_parse_image:
- err_parse_options:
-	return rc;
+	return imgsingle_exec ( argc, argv, &imgargs_desc );
 }
 
-/** "imgexec" options */
-struct imgexec_options {};
+/** "img{multi}" options */
+struct imgmulti_options {};
 
-/** "imgexec" option list */
-static struct option_descriptor imgexec_opts[] = {};
+/** "img{multi}" option list */
+static struct option_descriptor imgmulti_opts[] = {};
 
-/** "imgexec" command descriptor */
-static struct command_descriptor imgexec_cmd =
-	COMMAND_DESC ( struct imgexec_options, imgexec_opts, 0, 1,
-		       "[<image>]" );
+/** "img{multi}" command descriptor */
+static struct command_descriptor imgmulti_cmd =
+	COMMAND_DESC ( struct imgmulti_options, imgmulti_opts, 0, MAX_ARGUMENTS,
+		       "[<image>...]" );
 
 /**
- * The "imgexec" command
+ * The "img{multi}" family of commands
  *
  * @v argc		Argument count
  * @v argv		Argument list
+ * @v payload		Function to execute on each image
  * @ret rc		Return status code
  */
-static int imgexec_exec ( int argc, char **argv ) {
-	struct imgexec_options opts;
+static int imgmulti_exec ( int argc, char **argv,
+			   void ( * payload ) ( struct image *image ) ) {
+	struct imgmulti_options opts;
 	struct image *image;
+	struct image *tmp;
+	int i;
 	int rc;
 
 	/* Parse options */
-	if ( ( rc = parse_options ( argc, argv, &imgexec_cmd, &opts ) ) != 0 )
+	if ( ( rc = parse_options ( argc, argv, &imgmulti_cmd, &opts ) ) != 0 )
 		return rc;
 
-	/* Parse image name */
-	if ( optind < argc ) {
-		if ( ( rc = parse_image ( argv[optind], &image ) ) != 0 )
-			return rc;
-	} else {
-		image = imgautoselect();
-		if ( ! image ) {
-			rc = -ENOTTY;
-			printf ( "No image selected: %s\n", strerror ( rc ) );
-			return rc;
-		}
+	/* If no images are explicitly specified, process all images */
+	if ( optind == argc ) {
+		for_each_image_safe ( image, tmp )
+			payload ( image );
+		return 0;
 	}
 
-	/* Execute image */
-	if ( ( rc = imgexec ( image ) ) != 0 ) {
-		printf ( "Could not execute %s: %s\n",
-			 image->name, strerror ( rc ) );
-		return rc;
+	/* Otherwise, process specified images */
+	for ( i = optind ; i < argc ; i++ ) {
+		image = find_image ( argv[i] );
+		if ( ! image ) {
+			printf ( "\"%s\": no such image\n", argv[i] );
+			return -ENOENT;
+		}
+		payload ( image );
 	}
 
 	return 0;
 }
 
-/** "imgstat" options */
-struct imgstat_options {};
-
-/** "imgstat" option list */
-static struct option_descriptor imgstat_opts[] = {};
-
-/** "imgstat" command descriptor */
-static struct command_descriptor imgstat_cmd =
-	COMMAND_DESC ( struct imgstat_options, imgstat_opts, 0, 0, "" );
-
 /**
  * The "imgstat" command
  *
@@ -311,33 +359,9 @@ static struct command_descriptor imgstat_cmd =
  * @ret rc		Return status code
  */
 static int imgstat_exec ( int argc, char **argv ) {
-	struct imgstat_options opts;
-	struct image *image;
-	int rc;
-
-	/* Parse options */
-	if ( ( rc = parse_options ( argc, argv, &imgstat_cmd, &opts ) ) != 0 )
-		return rc;
-
-	/* Show status of all images */
-	for_each_image ( image ) {
-		imgstat ( image );
-	}
-
-	return 0;
+	return imgmulti_exec ( argc, argv, imgstat );
 }
 
-/** "imgfree" options */
-struct imgfree_options {};
-
-/** "imgfree" option list */
-static struct option_descriptor imgfree_opts[] = {};
-
-/** "imgfree" command descriptor */
-static struct command_descriptor imgfree_cmd =
-	COMMAND_DESC ( struct imgfree_options, imgfree_opts, 0, 1,
-		       "[<image>]" );
-
 /**
  * The "imgfree" command
  *
@@ -346,28 +370,7 @@ static struct command_descriptor imgfree_cmd =
  * @ret rc		Return status code
  */
 static int imgfree_exec ( int argc, char **argv ) {
-	struct imgfree_options opts;
-	struct image *image;
-	struct image *tmp;
-	int rc;
-
-	/* Parse options */
-	if ( ( rc = parse_options ( argc, argv, &imgfree_cmd, &opts ) ) != 0 )
-		return rc;
-
-	if ( optind < argc ) {
-		/* Free specified image */
-		if ( ( rc = parse_image ( argv[optind], &image ) ) != 0 )
-			return rc;
-		imgfree ( image );
-	} else {
-		/* Free all images */
-		list_for_each_entry_safe ( image, tmp, &images, list ) {
-			imgfree ( image );
-		}
-	}
-
-	return 0;
+	return imgmulti_exec ( argc, argv, unregister_image );
 }
 
 /** Image management commands */
@@ -386,19 +389,19 @@ struct command image_commands[] __command = {
 	},
 	{
 		.name = "kernel",
-		.exec = kernel_exec,
+		.exec = imgselect_exec, /* synonym for "imgselect" */
 	},
 	{
 		.name = "chain",
-		.exec = chain_exec,
+		.exec = imgexec_exec, /* synonym for "imgexec" */
 	},
 	{
 		.name = "imgselect",
 		.exec = imgselect_exec,
 	},
 	{
-		.name = "imgload", /* synonym for "imgselect" */
-		.exec = imgselect_exec,
+		.name = "imgload",
+		.exec = imgselect_exec, /* synonym for "imgselect" */
 	},
 	{
 		.name = "imgargs",
diff --git a/roms/ipxe/src/hci/commands/image_trust_cmd.c b/roms/ipxe/src/hci/commands/image_trust_cmd.c
new file mode 100644
index 0000000000000000000000000000000000000000..e7a2bf122c33ba82f4edf248ec79e23a090c6424
--- /dev/null
+++ b/roms/ipxe/src/hci/commands/image_trust_cmd.c
@@ -0,0 +1,173 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <stdint.h>
+#include <stdio.h>
+#include <getopt.h>
+#include <ipxe/image.h>
+#include <ipxe/command.h>
+#include <ipxe/parseopt.h>
+#include <usr/imgmgmt.h>
+#include <usr/imgtrust.h>
+
+/** @file
+ *
+ * Image trust management commands
+ *
+ */
+
+/** "imgtrust" options */
+struct imgtrust_options {
+	/** Allow trusted images */
+	int allow;
+	/** Make trust requirement permanent */
+	int permanent;
+};
+
+/** "imgtrust" option list */
+static struct option_descriptor imgtrust_opts[] = {
+	OPTION_DESC ( "allow", 'a', no_argument,
+		      struct imgtrust_options, allow, parse_flag ),
+	OPTION_DESC ( "permanent", 'p', no_argument,
+		      struct imgtrust_options, permanent, parse_flag ),
+};
+
+/** "imgtrust" command descriptor */
+static struct command_descriptor imgtrust_cmd =
+	COMMAND_DESC ( struct imgtrust_options, imgtrust_opts, 0, 0,
+		       "[--allow] [--permanent]" );
+
+/**
+ * The "imgtrust" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int imgtrust_exec ( int argc, char **argv ) {
+	struct imgtrust_options opts;
+	int rc;
+
+	/* Parse options */
+	if ( ( rc = parse_options ( argc, argv, &imgtrust_cmd, &opts ) ) != 0 )
+		return rc;
+
+	/* Set trust requirement */
+	if ( ( rc = image_set_trust ( ( ! opts.allow ),
+				      opts.permanent ) ) != 0 ) {
+		printf ( "Could not set image trust requirement: %s\n",
+			 strerror ( rc ) );
+		return rc;
+	}
+
+	return 0;
+}
+
+/** "imgverify" options */
+struct imgverify_options {
+	/** Required signer common name */
+	const char *signer;
+	/** Keep signature after verification */
+	int keep;
+};
+
+/** "imgverify" option list */
+static struct option_descriptor imgverify_opts[] = {
+	OPTION_DESC ( "signer", 's', required_argument,
+		      struct imgverify_options, signer, parse_string ),
+	OPTION_DESC ( "keep", 'k', no_argument,
+		      struct imgverify_options, keep, parse_flag ),
+};
+
+/** "imgverify" command descriptor */
+static struct command_descriptor imgverify_cmd =
+	COMMAND_DESC ( struct imgverify_options, imgverify_opts, 2, 2,
+		       "[--signer <signer>] [--keep] <uri|image> "
+		       "<signature uri|image>" );
+
+/**
+ * The "imgverify" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int imgverify_exec ( int argc, char **argv ) {
+	struct imgverify_options opts;
+	const char *image_name_uri;
+	const char *signature_name_uri;
+	struct image *image;
+	struct image *signature;
+	int rc;
+
+	/* Parse options */
+	if ( ( rc = parse_options ( argc, argv, &imgverify_cmd, &opts ) ) != 0 )
+		return rc;
+
+	/* Parse image name/URI string */
+	image_name_uri = argv[optind];
+
+	/* Parse signature name/URI string */
+	signature_name_uri = argv[ optind + 1 ];
+
+	/* Acquire the image */
+	if ( ( rc = imgacquire ( image_name_uri, &image ) ) != 0 )
+		goto err_acquire_image;
+
+	/* Acquire the signature image */
+	if ( ( rc = imgacquire ( signature_name_uri, &signature ) ) != 0 )
+		goto err_acquire_signature;
+
+	/* Verify image */
+	if ( ( rc = imgverify ( image, signature, opts.signer ) ) != 0 ) {
+		printf ( "Could not verify: %s\n", strerror ( rc ) );
+		goto err_verify;
+	}
+
+	/* Success */
+	rc = 0;
+
+ err_verify:
+	/* Discard signature unless --keep was specified */
+	if ( ! opts.keep )
+		unregister_image ( signature );
+ err_acquire_signature:
+ err_acquire_image:
+	return rc;
+}
+
+/** Image trust management commands */
+struct command image_trust_commands[] __command = {
+	{
+		.name = "imgtrust",
+		.exec = imgtrust_exec,
+	},
+	{
+		.name = "imgverify",
+		.exec = imgverify_exec,
+	},
+};
+
+/* Drag in objects typically required for signature verification */
+REQUIRE_OBJECT ( rsa );
+REQUIRE_OBJECT ( md5 );
+REQUIRE_OBJECT ( sha1 );
+REQUIRE_OBJECT ( sha256 );
diff --git a/roms/ipxe/src/hci/commands/iwmgmt_cmd.c b/roms/ipxe/src/hci/commands/iwmgmt_cmd.c
index 00a8360db9c0a83b3ad119cb8fa6..d91ad1e3435d3363d84ed97d3f78 100644
--- a/roms/ipxe/src/hci/commands/iwmgmt_cmd.c
+++ b/roms/ipxe/src/hci/commands/iwmgmt_cmd.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/hci/commands/login_cmd.c b/roms/ipxe/src/hci/commands/login_cmd.c
index 3286932d00e57f9d5d15ea1f9fe8..bc23e6ff52c370f456f55f5f9715 100644
--- a/roms/ipxe/src/hci/commands/login_cmd.c
+++ b/roms/ipxe/src/hci/commands/login_cmd.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 #include <string.h>
diff --git a/roms/ipxe/src/hci/commands/lotest_cmd.c b/roms/ipxe/src/hci/commands/lotest_cmd.c
index 172be2d8ce77d1906dd76d42c3b6..92f08887aedb06500c23b4fd0c8d 100644
--- a/roms/ipxe/src/hci/commands/lotest_cmd.c
+++ b/roms/ipxe/src/hci/commands/lotest_cmd.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/hci/commands/menu_cmd.c b/roms/ipxe/src/hci/commands/menu_cmd.c
new file mode 100644
index 0000000000000000000000000000000000000000..10966db273fd91b44bbe53c71593294cae6685bc
--- /dev/null
+++ b/roms/ipxe/src/hci/commands/menu_cmd.c
@@ -0,0 +1,286 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Menu commands
+ *
+ */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <errno.h>
+#include <getopt.h>
+#include <ipxe/menu.h>
+#include <ipxe/command.h>
+#include <ipxe/parseopt.h>
+#include <ipxe/settings.h>
+#include <ipxe/features.h>
+
+FEATURE ( FEATURE_MISC, "Menu", DHCP_EB_FEATURE_MENU, 1 );
+
+/** "menu" options */
+struct menu_options {
+	/** Name */
+	const char *name;
+	/** Delete */
+	int delete;
+};
+
+/** "menu" option list */
+static struct option_descriptor menu_opts[] = {
+	OPTION_DESC ( "name", 'n', required_argument,
+		      struct menu_options, name, parse_string ),
+	OPTION_DESC ( "delete", 'd', no_argument,
+		      struct menu_options, delete, parse_flag ),
+};
+
+/** "menu" command descriptor */
+static struct command_descriptor menu_cmd =
+	COMMAND_DESC ( struct menu_options, menu_opts, 0, MAX_ARGUMENTS,
+		       "[--name <name>] [--delete] [<title>]" );
+
+/**
+ * The "menu" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int menu_exec ( int argc, char **argv ) {
+	struct menu_options opts;
+	struct menu *menu;
+	char *title;
+	int rc;
+
+	/* Parse options */
+	if ( ( rc = parse_options ( argc, argv, &menu_cmd, &opts ) ) != 0 )
+		goto err_parse_options;
+
+	/* Parse title */
+	title = concat_args ( &argv[optind] );
+	if ( ! title ) {
+		rc = -ENOMEM;
+		goto err_parse_title;
+	}
+
+	/* Create menu */
+	menu = create_menu ( opts.name, title );
+	if ( ! menu ) {
+		rc = -ENOMEM;
+		goto err_create_menu;
+	}
+
+	/* Destroy menu, if applicable */
+	if ( opts.delete )
+		destroy_menu ( menu );
+
+	/* Success */
+	rc = 0;
+
+ err_create_menu:
+	free ( title );
+ err_parse_title:
+ err_parse_options:
+	return rc;
+}
+
+/** "item" options */
+struct item_options {
+	/** Menu name */
+	const char *menu;
+	/** Shortcut key */
+	unsigned int key;
+	/** Use as default */
+	int is_default;
+	/** Use as a separator */
+	int is_gap;
+};
+
+/** "item" option list */
+static struct option_descriptor item_opts[] = {
+	OPTION_DESC ( "menu", 'm', required_argument,
+		      struct item_options, menu, parse_string ),
+	OPTION_DESC ( "key", 'k', required_argument,
+		      struct item_options, key, parse_key ),
+	OPTION_DESC ( "default", 'd', no_argument,
+		      struct item_options, is_default, parse_flag ),
+	OPTION_DESC ( "gap", 'g', no_argument,
+		      struct item_options, is_gap, parse_flag ),
+};
+
+/** "item" command descriptor */
+static struct command_descriptor item_cmd =
+	COMMAND_DESC ( struct item_options, item_opts, 0, MAX_ARGUMENTS,
+		       "[--menu <menu>] [--key <key>] [--default] "
+		       "[<label>|--gap [<text>]]" );
+
+/**
+ * The "item" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int item_exec ( int argc, char **argv ) {
+	struct item_options opts;
+	struct menu *menu;
+	struct menu_item *item;
+	char *label = NULL;
+	char *text = NULL;
+	int rc;
+
+	/* Parse options */
+	if ( ( rc = parse_options ( argc, argv, &item_cmd, &opts ) ) != 0 )
+		goto err_parse_options;
+
+	/* Parse label, if present */
+	if ( ! opts.is_gap )
+		label = argv[optind++]; /* May be NULL */
+
+	/* Parse text, if present */
+	if ( optind < argc ) {
+		text = concat_args ( &argv[optind] );
+		if ( ! text ) {
+			rc = -ENOMEM;
+			goto err_parse_text;
+		}
+	}
+
+	/* Identify menu */
+	if ( ( rc = parse_menu ( opts.menu, &menu ) ) != 0 )
+		goto err_parse_menu;
+
+	/* Add menu item */
+	item = add_menu_item ( menu, label, ( text ? text : "" ),
+			       opts.key, opts.is_default );
+	if ( ! item ) {
+		rc = -ENOMEM;
+		goto err_add_menu_item;
+	}
+
+	/* Success */
+	rc = 0;
+
+ err_add_menu_item:
+ err_parse_menu:
+	free ( text );
+ err_parse_text:
+ err_parse_options:
+	return rc;
+}
+
+/** "choose" options */
+struct choose_options {
+	/** Menu name */
+	const char *menu;
+	/** Timeout */
+	unsigned int timeout;
+	/** Default selection */
+	const char *select;
+	/** Keep menu */
+	int keep;
+};
+
+/** "choose" option list */
+static struct option_descriptor choose_opts[] = {
+	OPTION_DESC ( "menu", 'm', required_argument,
+		      struct choose_options, menu, parse_string ),
+	OPTION_DESC ( "default", 'd', required_argument,
+		      struct choose_options, select, parse_string ),
+	OPTION_DESC ( "timeout", 't', required_argument,
+		      struct choose_options, timeout, parse_integer ),
+	OPTION_DESC ( "keep", 'k', no_argument,
+		      struct choose_options, keep, parse_flag ),
+};
+
+/** "choose" command descriptor */
+static struct command_descriptor choose_cmd =
+	COMMAND_DESC ( struct choose_options, choose_opts, 1, 1,
+		       "[--menu <menu>] [--default <label>] "
+		       "[--timeout <timeout>] [--keep] <setting>" );
+
+/**
+ * The "choose" command
+ *
+ * @v argc		Argument count
+ * @v argv		Argument list
+ * @ret rc		Return status code
+ */
+static int choose_exec ( int argc, char **argv ) {
+	struct choose_options opts;
+	struct menu *menu;
+	struct menu_item *item;
+	const char *setting;
+	int rc;
+
+	/* Parse options */
+	if ( ( rc = parse_options ( argc, argv, &choose_cmd, &opts ) ) != 0 )
+		goto err_parse_options;
+
+	/* Parse setting name */
+	setting = argv[optind];
+
+	/* Identify menu */
+	if ( ( rc = parse_menu ( opts.menu, &menu ) ) != 0 )
+		goto err_parse_menu;
+
+	/* Show menu */
+	if ( ( rc = show_menu ( menu, opts.timeout, opts.select, &item ) ) != 0)
+		goto err_show_menu;
+
+	/* Store setting */
+	if ( ( rc = storef_named_setting ( setting, &setting_type_string,
+					   item->label ) ) != 0 ) {
+		printf ( "Could not store \"%s\": %s\n",
+			 setting, strerror ( rc ) );
+		goto err_store;
+	}
+
+	/* Success */
+	rc = 0;
+
+ err_store:
+ err_show_menu:
+	/* Destroy menu, if applicable */
+	if ( ! opts.keep )
+		destroy_menu ( menu );
+ err_parse_menu:
+ err_parse_options:
+	return rc;
+}
+
+/** Menu commands */
+struct command menu_commands[] __command = {
+	{
+		.name = "menu",
+		.exec = menu_exec,
+	},
+	{
+		.name = "item",
+		.exec = item_exec,
+	},
+	{
+		.name = "choose",
+		.exec = choose_exec,
+	},
+};
